d("myAddressBookView",['util','ccrz'], function(util,addressBookView) {

    return {
        extendAddressbookView: function(addressBookView) {    
            console.log('--in customAddressBookView--');
            // CCRZ.subsc = _.extend(CCRZ.subsc||{}); 
            // CCRZ.subsc.addressBookRemoting =  _.extend(CCRZ.RemoteInvocation,{ 
            //     className : 'OXB2B_myAccountController', 
            //     fetchAccountAddresses : function( reqData,callback){ 
            //         this.invokeCtx('fetchAccountAddresses', 
            //                 reqData,  
            //                         function(resp, evt){ 
            //                             if(callback){
            //                                 callback(resp,evt);
            //                             }            
            //                         }, 
            //                         { 
            //                             buffer:false, //this call will be executed by itself 
            //                             nmsp : false //defines that this is a call to a subscriber class 
            //                         } 
            //                     );//end invokeCtx call 
            //     }
            // }); 
            let adressMap = {};
            let selectedAddressId = '';
            // Override My address book View
            CCRZ.pubSub.once('view:myAddressBookView:refresh', function(myAddressView){
                myAddressView.postRender = function(){
                    fetchAddresses();
                };
                myAddressView.events["click .cc_edit_address_btn"]  = "editAddress";
                myAddressView.events["click .cc_delete_address_btn"]  = "deleteAddress";
                myAddressView.events["change #countrySectionShip"] = "countryChange";
                myAddressView.events["click .closeEditAddressModel"] = "closeEditAddressModel";
                myAddressView.events["click .saveAddress"] = "saveAddress";

                myAddressView.editAddress = function(e){
                    console.log('--in editAddress--'+ e.currentTarget.dataset.id);
                    var addId = e.currentTarget.dataset.id;
                    selectedAddressId = addId;
                    $('#editAddress').modal('show');

                    //pre populate address values
                    document.getElementById('add_Fname').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__FirstName__c;
                    document.getElementById('add_Sname').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__LastName__c;
                    if(adressMap[addId].ccrz__E_ContactAddress__r.ccrz__CompanyName__c != undefined) {
                        document.getElementById('add_Cmpny').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__CompanyName__c;
                    }
                    else {
                        document.getElementById('add_Cmpny').value = adressMap[addId].ccrz__Account__r.Name;
                    }
                    document.getElementById('add_Address1').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__AddressFirstline__c;
                    if(adressMap[addId].ccrz__E_ContactAddress__r.ccrz__AddressSecondline__c != undefined) {
                        document.getElementById('add_Address2').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__AddressSecondline__c;
                    }
                    document.getElementById('countrySectionShip').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__Country__c;
                    
                    var countryCode = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__Country__c;
                    let stateList = document.getElementById('add_State');
                    var options = '';
                    if (countryCode == 'CA') {
                        options= '<option value="">--Select State--</option><option value="AB">AB</option><option value="BC">BC</option><option value="MB">MB</option><option value="NB">NB</option><option value="NL">NL</option><option value="NT">NT</option><option value="NS">NS</option><option value="NU">NU</option><option value="ON">ON</option><option value="PE">PE</option><option value="QC">QC</option><option value="SK">SK</option><option value="YT">YT</option>';     
                        stateList.innerHTML=options;  
                    }
                    else if (countryCode == 'US') {
                        options= '<option value="">--Select State--</option><option value="AL">AL</option><option value="AZ">AZ</option><option value="AR">AR</option><option value="CA">CA</option><option value="CO">CO</option><option value="CT">CT</option><option value="DE">DE</option><option value="DC">DC</option><option value="FL">FL</option><option value="GA">GA</option><option value="ID">ID</option><option value="IL">IL</option><option value="IN">IN</option><option value="IA">IA</option><option value="KS">KS</option><option value="KY">KY</option><option value="LA">LA</option><option value="ME">ME</option><option value="MD">MD</option><option value="MA">MA</option><option value="MI">MI</option><option value="MN">MN</option><option value="MS">MS</option><option value="MO">MO</option><option value="MT">MT</option><option value="NE">NE</option><option value="NV">NV</option><option value="NH">NH</option><option value="NJ">NJ</option><option value="NM">NM</option><option value="NY">NY</option><option value="NC">NC</option><option value="ND">ND</option><option value="OH">OH</option><option value="OK">OK</option><option value="OR">OR</option><option value="PA">PA</option><option value="RI">RI</option><option value="SC">SC</option><option value="SD">SD</option><option value="TN">TN</option><option value="TX">TX</option><option value="UT">UT</option><option value="VT">VT</option><option value="VA">VA</option><option value="WA">WA</option><option value="WV">WV</option><option value="WI">WI</option><option value="WY">WY</option>';
                    }
                    stateList.innerHTML=options; 

                    document.getElementById('add_State').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__State__c;
                    document.getElementById('add_City').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__City__c;
                    document.getElementById('add_PostalCode').value = adressMap[addId].ccrz__E_ContactAddress__r.ccrz__PostalCode__c;
                }

                myAddressView.closeEditAddressModel = function(e) {
                    $('#editAddress').modal('hide');
                    //reset address values
                    selectedAddressId = '';
                    document.getElementById('add_Fname').value = '';
                    document.getElementById('add_Sname').value = '';
                    document.getElementById('add_Cmpny').value = '';
                    document.getElementById('add_Address1').value = '';
                    document.getElementById('add_Address2').value = '';
                    document.getElementById('countrySectionShip').value = '';
                    document.getElementById('add_State').value = '';
                    document.getElementById('add_City').value = '';
                    document.getElementById('add_PostalCode').value = '';
                }

                myAddressView.saveAddress = function(e) {
                    var allowSave = true;
                    let dataMap = {
                        id : selectedAddressId,
                        firstName : document.getElementById('add_Fname').value,
                        lastName : document.getElementById('add_Sname').value,
                        company : document.getElementById('add_Cmpny').value,
                        add1 : document.getElementById('add_Address1').value,
                        add2 : document.getElementById('add_Address2').value,
                        country : document.getElementById('countrySectionShip').value,
                        state : document.getElementById('add_State').value,
                        city : document.getElementById('add_City').value,
                        zip : document.getElementById('add_PostalCode').value
                    };
                    //verify address details
                    $(".editShippAddressErorMsg").html("");
                    $(".editShippAddressErorMsg").hide();
                    if (dataMap.firstName=="" || dataMap.lastName=="" || dataMap.company=="" || dataMap.add1=="" || dataMap.state=="" || dataMap.country=="" ||  dataMap.zip=="" || dataMap.city=="") {
                        allowSave=false;
                       $(".editShippAddressErorMsg").html("First Name, Last Name, Company Name, Address First Line, City, State and Country, Postal code can not be empty");
                       $(".editShippAddressErorMsg").show();
                    }

                    if(allowSave == true) {
                        console.log('--updateMap--'+ JSON.stringify(dataMap));
                        updateAddress(dataMap);
                    }

                    
                }

                myAddressView.deleteAddress = function(e) {
                    var addId = e.currentTarget.dataset.id;
                    selectedAddressId = addId;
                    let dataMap = {
                        id : selectedAddressId
                    };
                    console.log('--deleteMap--'+ JSON.stringify(dataMap));
                    removeAddress(dataMap);
                }

                myAddressView.countryChange = function(e) {
                    var countryCode = e.currentTarget.value;
                    let stateList = document.getElementById('add_State');
                    var options = '';
                    if (countryCode == 'CA') {
                        options= '<option value="">--Select State--</option><option value="AB">AB</option><option value="BC">BC</option><option value="MB">MB</option><option value="NB">NB</option><option value="NL">NL</option><option value="NT">NT</option><option value="NS">NS</option><option value="NU">NU</option><option value="ON">ON</option><option value="PE">PE</option><option value="QC">QC</option><option value="SK">SK</option><option value="YT">YT</option>';     
                        stateList.innerHTML=options;  
                    }
                    else if (countryCode == 'US') {
                        options= '<option value="">--Select State--</option><option value="AL">AL</option><option value="AZ">AZ</option><option value="AR">AR</option><option value="CA">CA</option><option value="CO">CO</option><option value="CT">CT</option><option value="DE">DE</option><option value="DC">DC</option><option value="FL">FL</option><option value="GA">GA</option><option value="ID">ID</option><option value="IL">IL</option><option value="IN">IN</option><option value="IA">IA</option><option value="KS">KS</option><option value="KY">KY</option><option value="LA">LA</option><option value="ME">ME</option><option value="MD">MD</option><option value="MA">MA</option><option value="MI">MI</option><option value="MN">MN</option><option value="MS">MS</option><option value="MO">MO</option><option value="MT">MT</option><option value="NE">NE</option><option value="NV">NV</option><option value="NH">NH</option><option value="NJ">NJ</option><option value="NM">NM</option><option value="NY">NY</option><option value="NC">NC</option><option value="ND">ND</option><option value="OH">OH</option><option value="OK">OK</option><option value="OR">OR</option><option value="PA">PA</option><option value="RI">RI</option><option value="SC">SC</option><option value="SD">SD</option><option value="TN">TN</option><option value="TX">TX</option><option value="UT">UT</option><option value="VT">VT</option><option value="VA">VA</option><option value="WA">WA</option><option value="WV">WV</option><option value="WI">WI</option><option value="WY">WY</option>';
                    }
                    stateList.innerHTML=options; 

                }


                myAddressView.delegateEvents();
                myAddressView.render();
            });

            function fetchAddresses() {
                let accId = CCRZ.pagevars.effAccountId;
                let reqData = {effAccountId : accId};
                console.log(reqData);
                var remoteCall = _.extend(CCRZ.RemoteInvocation,{className:'OXB2B_myAccountController'});
                remoteCall.invokeCtx(
                    'fetchAccountAddresses',(JSON.stringify(reqData)),
                    function(res,event){
                        if(event.status){
                            let addressData = event.result.data; 
                            if(addressData.success) {
                                let addressList = addressData.addresses;
                                console.log('addressList--' + JSON.stringify(addressData));
                                var i = 0;
                                var addressHTML = addressData.addressHTML;
                                $("#tableBody").html(addressHTML);
                                adressMap = addressData;
                            }                       

                        }
                    },{buffer:false,escape:false,nmsp:false}
                );
            }

            function updateAddress(reqData) {
                console.log(reqData);
                var remoteCall = _.extend(CCRZ.RemoteInvocation,{className:'OXB2B_myAccountController'});
                remoteCall.invokeCtx(
                    'updateAccountAddress',(JSON.stringify(reqData)),
                    function(res,event){
                        if(event.status){
                            let addressData = event.result.data; 
                            if(addressData.success) {
                                $('#editAddress').modal('hide');
                                //reset address values
                                selectedAddressId = '';
                                document.getElementById('add_Fname').value = '';
                                document.getElementById('add_Sname').value = '';
                                document.getElementById('add_Cmpny').value = '';
                                document.getElementById('add_Address1').value = '';
                                document.getElementById('add_Address2').value = '';
                                document.getElementById('countrySectionShip').value = '';
                                document.getElementById('add_State').value = '';
                                document.getElementById('add_City').value = '';
                                document.getElementById('add_PostalCode').value = '';
                                fetchAddresses();
                            }                       

                        }
                    },{buffer:false,escape:false,nmsp:false}
                );
            }

            function removeAddress(reqData) {
                console.log(reqData);
                var remoteCall = _.extend(CCRZ.RemoteInvocation,{className:'OXB2B_myAccountController'});
                remoteCall.invokeCtx(
                    'deleteAccountAddress',(JSON.stringify(reqData)),
                    function(res,event){
                        if(event.status){
                            let addressData = event.result.data; 
                            if(addressData.success) {
                                selectedAddressId = '';
                                fetchAddresses();
                            }                       

                        }
                    },{buffer:false,escape:false,nmsp:false}
                );
            }
        }
    }


});